package com.gic.plug.web.controller.goods;

import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.goods.api.dto.CategoryDTO;
import com.gic.goods.api.dto.ErrorCode;
import com.gic.goods.api.service.CategoryApiService;
import com.gic.goods.api.util.Constant;
import com.gic.plug.web.vo.goods.CategoryVO;

@RestController
public class GoodsCategoryController {

    @Autowired
    private CategoryApiService categoryApiSerivce;

    /**
     * @Description: 查询所有（一级类目）
     * @author xub
     */
    @GetMapping("list-parent-category")
    public RestResponse listParentCord(String channelCode, Long goodsDomainId) {

        if (goodsDomainId == null || StringUtils.isBlank(channelCode)) {
            return RestResponse.failure(ErrorCode.UNKNOW_ERROR.getCode(), "参数不全");
        }
        ServiceResponse<List<CategoryDTO>> serviceResponse = categoryApiSerivce.listParentAll(channelCode, goodsDomainId, null, Constant.TEST_ENTERPRISE_ID);
        List<CategoryDTO> result = serviceResponse.getResult();
        if (CollectionUtils.isEmpty(result)) {
            return RestResponse.success();
        }
        List<CategoryVO> list = EntityUtil.changeEntityListByOrika(CategoryVO.class, result);
        return RestResponse.success(list);
    }

    /**
     * @Description: 查询所有（二级类目）
     * @author xub
     */
    @GetMapping("list-child-category")
    public RestResponse listChildAll(String channelCode, Long specParentId) {

        if (specParentId == null || StringUtils.isBlank(channelCode)) {
            return RestResponse.failure(ErrorCode.UNKNOW_ERROR.getCode(), "参数不全");
        }
        ServiceResponse<List<CategoryDTO>> serviceResponse = categoryApiSerivce.listChildAll(channelCode, specParentId, null, Constant.TEST_ENTERPRISE_ID);
        List<CategoryDTO> result = serviceResponse.getResult();
        if (CollectionUtils.isEmpty(result)) {
            return RestResponse.success();
        }
        List<CategoryVO> list = EntityUtil.changeEntityListByOrika(CategoryVO.class, result);
        return RestResponse.success(list);
    }

}
